<?php
/*
Plugin Name: Extended Description
Version: 1.7.2.a
Description: Permet d'avoir une description mutilingue. Permet galement d'avoir une description rduite/tendue pour les catgories.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=175
Author: P@t
Author URI: http://www.gauchon.com
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
define('EXTENDED_DESC_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

global $conf;

$extdesc_conf = array(
  'more' => '<!--more-->',
  'complete' => '<!--complete-->',
  'up-down' => '<!--up-down-->',
  'not_visible' => '<!--hidden-->'
);

$conf['ExtendedDescription'] = isset($conf['ExtendedDescription']) ?
  array_merge($extdesc_conf, $conf['ExtendedDescription']) :
  $extdesc_conf;


// Traite les balises [lang=xx]
function get_user_language_desc($desc)
{
	global $user;
  
	$user_lang = substr($user['language'], 0, 2);

	if (!substr_count(strtolower($desc), '[lang=' . $user_lang . ']'))
	{
		$user_lang = 'default';
  }
  
  if (substr_count(strtolower($desc), '[lang=' . $user_lang . ']'))
	{
    // la balise avec la langue de l'utilisateur a t trouve
    $patterns[] = '#(\A|\[/lang\])(.*?)(\[lang=' . $user_lang . '\]|\Z)#is';
    $replacements[] = '';
    $patterns[] = '#\[lang=(' . $user_lang . '|all)\](.*?)\[/lang\]#is';
    $replacements[] = '\\1';
  }
  else
  {
    // la balise avec la langue de l'utilisateur n'a pas t trouve
    // On prend tout ce qui est hors balise
    $patterns[] = '#\[lang=all\](.*?)\[/lang\]#is';
    $replacements[] = '\\1';
    $patterns[] = '#\[lang=.*\].*\[/lang\]#is';
    $replacements[] = '';
  }
  return preg_replace($patterns, $replacements, $desc);
}

// Traite les autres balises
function get_extended_desc($desc, $param='')
{
	global $conf;
  
  $desc = get_user_language_desc($desc);
  
  // Balises [cat=xx]
  $patterns[] = '#\[cat=(\d*)\]#ie';
  $replacements[] = 'get_cat_thumb("$1")';
  
  // Balises [img=xx.yy;float]
  $patterns[] = '#\[img=(\d*)\.?(\d*|);?(left|right|)\]#ie';
  $replacements[] = 'get_img_thumb("$1", "$2", "$3")';
  
  // Balises <!--complete-->, <!--more--> et <!--up-down-->
	switch ($param)
	{
		case 'subcatify_category_description' :
      $patterns[] = '#\A(.*?)('. preg_quote($conf['ExtendedDescription']['complete']) . '|' . preg_quote($conf['ExtendedDescription']['more']) . '|' . preg_quote($conf['ExtendedDescription']['up-down']) . ').*\Z#is';
      $replacements[] = '$1';
      $desc = preg_replace($patterns, $replacements, $desc);
      break;
			
    case 'main_page_category_description' :
      $patterns[] = '#\A.*' . preg_quote($conf['ExtendedDescription']['complete']) . '|' . preg_quote($conf['ExtendedDescription']['more']) . '#is';
      $replacements[] = '';
      $desc = preg_replace($patterns, $replacements, $desc);
      if (substr_count($desc, $conf['ExtendedDescription']['up-down']))
      {
        list($conf['ExtendedDescription']['top_comment'], $desc) = explode($conf['ExtendedDescription']['up-down'], $desc);
        add_event_handler('loc_end_index', 'add_top_description');
      }
      break;
      
    default:
      $desc = preg_replace($patterns, $replacements, $desc);
	}

  return $desc;
}

function extended_desc_mail_group_assign_vars($assign_vars)
{
	if (isset($assign_vars['CPL_CONTENT']))
	{
		$assign_vars['CPL_CONTENT'] = get_extended_desc($assign_vars['CPL_CONTENT']);
	}
	return $assign_vars;
}

// Add top description
function add_top_description()
{
  global $template, $conf;
  $template->concat_var('MONTH_CALENDAR', '
  <div class="additional_info">
  ' . $conf['ExtendedDescription']['top_comment'] . '
  </div>');
}

// Remove a category
function ext_remove_cat($category, $param='')
{
  global $template, $conf;

  if (substr_count($category['name'], $conf['ExtendedDescription']['not_visible']))
  {
    $template->delete_block_vars($param);
  }
}

// Return html code for  caterogy thumb
function get_cat_thumb($elem_id)
{
  global $template;

  $query = 'SELECT cat.id, cat.name, cat.permalink,
              cat.representative_picture_id, cat.comment,
              cat.nb_images, cat.uppercats,
              cat.date_last, cat.global_rank,
              img.path, img.tn_ext
            FROM ' . CATEGORIES_TABLE . ' AS cat, ' . IMAGES_TABLE . ' AS img
            WHERE cat.id = ' . $elem_id . '
            AND img.id = cat.representative_picture_id;';
  $result = pwg_query($query);

  if($result)
  {
    $template->set_filename('extended_description_content', EXTENDED_DESC_PATH . 'template/cat.tpl');
    while($category=mysql_fetch_array($result))
    {
      $template->assign_vars(
        array(
          'SRC' => get_thumbnail_url($category),
          'ALT' => $category['name'],
          'URL' => make_index_url(array('category' => $category)),
          'NAME' => $category['name'],
          'CAPTION_NB_IMAGES'  => get_display_images_count(
                                    $category['nb_images'],
                                    $category['nb_images'],
                                    0,
                                    true,
                                    '<br />'),
          'DESCRIPTION' => trigger_event('render_category_literal_description',
            trigger_event('render_category_description',
              @$category['comment'],
              'subcatify_category_description'))));
    }
    return $template->parse('extended_description_content', true);
  }
  return '';
}

// Return html code for img thumb
function get_img_thumb($elem_id, $cat_id='', $align='')
{
  global $template;

  $query = 'SELECT * FROM ' . IMAGES_TABLE . ' WHERE id = ' . $elem_id . ';';
  $result = pwg_query($query);
  
  if($result)
  {
    $template->set_filename('extended_description_content', EXTENDED_DESC_PATH . 'template/img.tpl');
    while ($picture = mysql_fetch_array($result))
    {
      $template->assign_vars(
        array(
          'IMAGE'       => get_thumbnail_url($picture),
          'IMAGE_ALT'   => $picture['name'],
          'U_IMG_LINK'  => make_picture_url(
                            array(
                              'image_id' => $picture['id'],
                              'category' => array(
                                              'id' => !empty($cat_id) ? $cat_id : $picture['storage_category_id'],
                                              'name' => '',
                                              'permalink' => ''))),
          'CLASS' => 'thumbCat',
          'FLOAT' => !empty($align) ? 'float: ' . $align . ';' : '',
          'COMMENT' => $picture['name']));
    }
    return $template->parse('extended_description_content', true);
  }
  return '';
}


if (script_basename() == 'admin' or script_basename() == 'popuphelp')
{
  include(EXTENDED_DESC_PATH . 'admin.inc.php');
}

add_event_handler ('render_page_banner', 'get_user_language_desc');
add_event_handler ('render_category_name', 'get_user_language_desc');
add_event_handler ('render_category_description', 'get_extended_desc', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
add_event_handler ('render_element_description', 'get_extended_desc');
add_event_handler ('nbm_render_user_customize_mail_content', 'get_extended_desc');
add_event_handler ('mail_group_assign_vars', 'extended_desc_mail_group_assign_vars');
add_event_handler ('loc_index_category_thumbnail', 'ext_remove_cat', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);

?>